diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_intern.h PDFlib-Lite-7.0.4/libs/pdflib/p_intern.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_intern.h	2009-03-18 15:10:06.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_intern.h	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_intern.h,v 1.491.2.29 2009/03/03 21:12:37 kurt Exp $
+/* $Id: p_intern.h,v 1.491.2.32 2009/06/04 11:22:04 york Exp $
  *
  * PDFlib internal definitions
  *
@@ -205,6 +205,14 @@
 typedef struct pdf_xobject_s pdf_xobject;
 
 
+/* -------------------- transparency group -------------------- */
+typedef struct
+{
+    pdf_colortype       colorspace;     /* color space                  */
+    pdc_bool            isolated;       /* isolated flag I              */
+    pdc_bool            knockout;       /* knockout flag K              */
+} pdf_transgroup;
+
 /* -------------------- special graphics state -------------------- */
 typedef struct {
     pdc_matrix  ctm;            /* current transformation matrix */
@@ -237,16 +245,6 @@
 
     pdc_vtr *           mboxes;         /* matchbox chain */
 
-    /* in update mode, the resource numbers generally don't start
-    ** with 0, but with a bias value derived from the original
-    ** page's resources.
-    */
-    int			cs_bias;	/* colorspaces */
-    int			eg_bias;	/* extended gstates */
-    int			fn_bias;	/* fonts */
-    int			pt_bias;	/* patterns */
-    int			sh_bias;	/* shadings */
-    int			xo_bias;	/* xobjects */
 } pdf_ppt;
 
 /* Force graphics or color operator output, avoiding the optimization
@@ -826,6 +824,8 @@
 void pdf_set_pagebox_ury(PDF *p, pdf_pagebox box, pdc_scalar ury);
 void pdf_set_pagebox(PDF *p, pdf_pagebox box, pdc_scalar llx, pdc_scalar lly,
 	pdc_scalar urx, pdc_scalar ury);
+void pdf_set_transgroup(PDF *p, const char *optlist, pdf_transgroup *tgroup);
+void pdf_write_transgroup(PDF *p, pdf_transgroup *tgroup);
 
 pdc_vtr *pdf_get_annots_list(PDF *p);
 void pdf_set_annots_list(PDF *p, pdc_vtr *annots);
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_keyconn.h PDFlib-Lite-7.0.4/libs/pdflib/p_keyconn.h
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_keyconn.h	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_keyconn.h	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_keyconn.h,v 1.117.2.17 2008/02/07 20:13:17 kurt Exp $
+/* $Id: p_keyconn.h,v 1.117.2.18 2009/04/15 12:06:35 york Exp $
  *
  * PDFlib shared keys connection lists
  *
@@ -422,6 +422,19 @@
 #endif /* P_MBOX_C */
 
 
+#if defined(P_PAGE_C) || defined(P_TEMPLATE_C)
+
+static const pdc_keyconn pdf_tgroup_cs_pdfkeylist[] =
+{
+    {"DeviceGray",   color_gray},
+    {"DeviceRGB",    color_rgb},
+    {"DeviceCMYK",   color_cmyk},
+    {NULL, 0}
+};
+
+#endif /* P_PAGE_C || P_TEMPLATE_C */
+
+
 #if defined(P_DOCUMENT_C) || defined(P_PARAMS_C)
 
 static const pdc_keyconn pdf_compatibility_keylist[] =
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_page.c PDFlib-Lite-7.0.4/libs/pdflib/p_page.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_page.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_page.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_page.c,v 1.116.2.20 2008/12/08 14:17:45 york Exp $
+/* $Id: p_page.c,v 1.116.2.24 2009/06/04 11:22:04 york Exp $
  *
  * PDFlib page related routines
  *
@@ -67,21 +67,6 @@
     {NULL, 0}
 };
 
-static const pdc_keyconn pdf_colorspace_pdfkeylist[] =
-{
-    {"DeviceGray",   color_gray},
-    {"DeviceRGB",    color_rgb},
-    {"DeviceCMYK",   color_cmyk},
-    {NULL, 0}
-};
-
-typedef struct
-{
-    pdf_colortype       colorspace;     /* color space                  */
-    pdc_bool            isolated;       /* isolated flag I              */
-    pdc_bool            knockout;       /* knockout flag K              */
-} pg_transgroup;
-
 typedef struct
 {
     pdf_labelstyle      style;          /* page label style             */
@@ -160,7 +145,7 @@
     pdc_scalar          userunit;       /* page user unit */
     char *		action;		/* "action" option string */
 
-    pg_transgroup       tgroup;         /* transparency group definition */
+    pdf_transgroup	tgroup;         /* transparency group definition */
     pdc_bool            autotgroup;     /* create transp. group automatically */
 
 
@@ -219,31 +204,28 @@
 /*********************** initialization & cleanup ***********************/
 
 static void
-pdf_init_ppt(PDF *p, pdc_bool new_ppt)
+pdf_init_ppt(PDF *p)
 {
     pdf_ppt *ppt = p->curr_ppt;
 
-    if (new_ppt)
-    {
-	ppt->cstate = 0;
-	ppt->tstate = 0;
+    ppt->cstate = (pdf_cstate *) 0;
+    ppt->tstate = (pdf_tstate *) 0;
 
-        ppt->mboxes = (pdc_vtr *) 0;
+    ppt->mboxes = (pdc_vtr *) 0;
 
-	ppt->cs_bias = 0;
-	ppt->eg_bias = 0;
-	ppt->fn_bias = 0;
-	ppt->pt_bias = 0;
-	ppt->sh_bias = 0;
-	ppt->xo_bias = 0;
-    }
+} /* pdf_init_ppt */
+
+static void
+pdf_init_ppt_states(PDF *p)
+{
+    pdf_ppt *ppt = p->curr_ppt;
 
     ppt->sl = 0;
 
     pdf_init_tstate(p);
     pdf_init_gstate(p);
     pdf_init_cstate(p);
-} /* pdf_init_ppt */
+} /* pdf_init_ppt_states */
 
 static void
 pdf_reset_ppt(pdf_ppt *ppt)
@@ -365,6 +347,9 @@
     dp->pages = (page_obj *) 0;
     dp->pnodes = (pdc_id *) 0;
 
+    p->curr_ppt = &dp->default_ppt;
+    pdf_init_ppt(p);
+
     dp->pages_capacity = PAGES_CHUNKSIZE;
     dp->pages = (page_obj *)
 	    pdc_malloc(p->pdc, sizeof (page_obj) * dp->pages_capacity, fn);
@@ -385,13 +370,6 @@
     dp->current_pnode	= 0;
     dp->current_pnode_kids = 0;
 
-    /* clients may set char/word spacing and horizontal scaling outside pages
-    ** for PDF_stringwidth() calculations, and they may set a color for use
-    ** in PDF_makespotcolor(). that's what default_ppt is good for.
-    */
-    p->curr_ppt = &dp->default_ppt;
-    pdf_init_ppt(p, pdc_true);
-
     for (i = 0; i < n_groups - 1; ++i)
 	for (k = i + 1; k < n_groups; ++k)
 	    if (strcmp(groups[i], groups[k]) == 0)
@@ -412,6 +390,13 @@
 	dp->groups[i].label.prefix = (char *) 0;
 	dp->groups[i].label.start = 0;
     }
+
+    /* clients may set char/word spacing and horizontal scaling outside pages
+    ** for PDF_stringwidth() calculations, and they may set a color for use
+    ** in PDF_makespotcolor(). that's what default_ppt is good for.
+    */
+    pdf_init_ppt_states(p);
+
 } /* pdf_init_pages */
 
 
@@ -808,22 +793,20 @@
 static const pdc_defopt pdf_transgroup_options[] =
 {
     {"CS", pdc_keywordlist, PDC_OPT_NONE, 1, 1,
-      1.0, PDC_INT_MAX, pdf_colorspace_pdfkeylist},
+      1.0, PDC_INT_MAX, pdf_tgroup_cs_pdfkeylist},
 
     {"I", pdc_booleanlist, PDC_OPT_NONE, 1, 1,
       0.0, 0.0, NULL},
 
-    {"K", pdc_booleanlist, PDC_OPT_NONE, 1, 1, \
-      0.0, 0.0, NULL}, \
+    {"K", pdc_booleanlist, PDC_OPT_NONE, 1, 1,
+      0.0, 0.0, NULL},
 
     PDC_OPT_TERMINATE
 };
 
-static void
-pdf_set_transgroup(PDF *p, const char *optlist, int pageno)
+void
+pdf_set_transgroup(PDF *p, const char *optlist, pdf_transgroup *tgroup)
 {
-    pdf_pages * dp = p->doc_pages;
-    page_obj *  po = &dp->pages[pageno];
     pdc_resopt *resopts = NULL;
     int         inum;
 
@@ -831,38 +814,28 @@
                                    NULL, pdc_true);
 
     if (pdc_get_optvalues("CS", resopts, &inum, NULL))
-        po->tgroup.colorspace = (pdf_colortype) inum;
+        tgroup->colorspace = (pdf_colortype) inum;
 
-    pdc_get_optvalues("I", resopts, &po->tgroup.isolated, NULL);
-    pdc_get_optvalues("K", resopts, &po->tgroup.knockout, NULL);
+    pdc_get_optvalues("I", resopts, &tgroup->isolated, NULL);
+    pdc_get_optvalues("K", resopts, &tgroup->knockout, NULL);
 }
 
-static void
-write_transgroup(PDF *p, int pageno)
+void
+pdf_write_transgroup(PDF *p, pdf_transgroup *tgroup)
 {
-    pdf_pages * dp = p->doc_pages;
-    page_obj *po = &dp->pages[pageno];
-
     pdc_puts(p->out, "/Group");
     pdc_begin_dict(p->out);
 
     pdc_puts(p->out, "/S/Transparency/CS/");
 
-    if (po->tgroup.colorspace != color_none)
-    {
-        pdc_printf(p->out, "%s", pdc_get_keyword(po->tgroup.colorspace,
-                                                 pdf_colorspace_pdfkeylist));
+    pdc_printf(p->out, "%s", pdc_get_keyword(tgroup->colorspace,
+					     pdf_tgroup_cs_pdfkeylist));
 
-        if (po->tgroup.isolated)
-            pdc_puts(p->out, "/I true");
+    if (tgroup->isolated)
+	pdc_puts(p->out, "/I true");
 
-        if (po->tgroup.knockout)
-            pdc_puts(p->out, "/K true");
-    }
-    else
-    {
-        pdc_puts(p->out, "DeviceRGB");
-    }
+    if (tgroup->knockout)
+	pdc_puts(p->out, "/K true");
 
     pdc_end_dict(p->out);
 }
@@ -1365,8 +1338,11 @@
 	    pdc_end_dict(p->out);
 	}
 
-        if (po->tgroup.colorspace != color_none || po->autotgroup)
-            write_transgroup(p, i);
+        if (po->tgroup.colorspace == color_none && po->autotgroup)
+	    po->tgroup.colorspace = color_rgb;
+
+        if (po->tgroup.colorspace != color_none)
+            pdf_write_transgroup(p, &po->tgroup);
 
 	pdf_write_box(p, po->boxes[pdf_artbox],		"ArtBox");
 	pdf_write_box(p, po->boxes[pdf_bleedbox],	"BleedBox");
@@ -1674,7 +1650,7 @@
     }
 
     if (pdc_get_optvalues("transparencygroup", resopts, NULL, &slist))
-        pdf_set_transgroup(p, slist[0], pageno);
+        pdf_set_transgroup(p, slist[0], &po->tgroup);
 
     /* the "width" and "height" options must be processed BEFORE the
     ** "mediabox" option, since the latter dominates over the formers.
@@ -1829,6 +1805,7 @@
 
     pg = dp->curr_pg = (pdf_page *) pdc_malloc(p->pdc, sizeof (pdf_page), fn);
     p->curr_ppt = &pg->ppt;
+    pdf_init_ppt(p);
 
     pg->contents_ids = (pdc_id *) 0;
     pg->annots = (pdc_vtr *) 0;
@@ -1867,7 +1844,7 @@
     /* initialize the current ppt descriptor. p->ydirection
     ** must be set before pdf_init_ppt()!
     */
-    pdf_init_ppt(p, pdc_true);
+    pdf_init_ppt_states(p);
 
     pg->next_content = 0;
 
@@ -1950,7 +1927,7 @@
 	p->curr_ppt = &dp->default_ppt;
     }
 
-    pdf_init_ppt(p, pdc_false);
+    pdf_init_ppt_states(p);
 } /* pdf_pg_suspend */
 
 
@@ -2237,7 +2214,7 @@
     /* restore the default ppt for out-of-page usage.
     */
     p->curr_ppt = &dp->default_ppt;
-    pdf_init_ppt(p, pdc_false);
+    pdf_init_ppt_states(p);
     PDF_SET_STATE(p, pdf_state_document);
     pdf_delete_page(p, pg);
     dp->curr_pg = (pdf_page *) 0;
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_pattern.c PDFlib-Lite-7.0.4/libs/pdflib/p_pattern.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_pattern.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_pattern.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_pattern.c,v 1.75.2.5 2007/08/28 18:02:32 kurt Exp $
+/* $Id: p_pattern.c,v 1.75.2.6 2009/06/04 11:22:04 york Exp $
  *
  * PDFlib pattern routines
  *
@@ -59,13 +59,12 @@
 pdf_write_page_pattern(PDF *p)
 {
     int i, total = 0;
-    int bias = p->curr_ppt->pt_bias;
 
     for (i = 0; i < p->pattern_number; i++)
 	if (p->pattern[i].used_on_current_page)
 	    total++;
 
-    if (total > 0 || bias)
+    if (total > 0)
     {
 	pdc_puts(p->out, "/Pattern");
 	pdc_begin_dict(p->out);
@@ -78,12 +77,11 @@
 	    if (p->pattern[i].used_on_current_page)
 	    {
 		p->pattern[i].used_on_current_page = pdc_false; /* reset */
-		pdc_printf(p->out, "/P%d", bias + i);
+		pdc_printf(p->out, "/P%d", i);
 		pdc_objref(p->out, "", p->pattern[i].obj_id);
 	    }
 	}
 
-	if (!bias)
 	    pdc_end_dict(p->out);
     }
 }
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_png.c PDFlib-Lite-7.0.4/libs/pdflib/p_png.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_png.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_png.c	2009-06-08 17:57:29.000000000 +0200
@@ -1,7 +1,7 @@
 /*---------------------------------------------------------------------------*
  |              PDFlib - A library for generating PDF on the fly             |
  +---------------------------------------------------------------------------+
- | Copyright (c) 1997-2006 Thomas Merz and PDFlib GmbH. All rights reserved. |
+ | Copyright (c) 1997-2009 Thomas Merz and PDFlib GmbH. All rights reserved. |
  +---------------------------------------------------------------------------+
  |                                                                           |
  |    This software is subject to the PDFlib license. It is NOT in the       |
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_png.c,v 1.94.2.7 2008/03/07 11:44:23 kurt Exp $
+/* $Id: p_png.c,v 1.94.2.10 2009/06/08 11:34:03 tm Exp $
  *
  * PNG processing for PDFlib
  *
@@ -24,173 +24,22 @@
 #define PDF_ALIGN16
 #endif
 
-/* SPNG - Simple PNG
-**
-** The items below, prefixed with spng_, or SPNG_, establish a replacement
-** for LIBPNG that works very fast, but processes simple PNG images only:
-**	- bit_depth <= 8 (no 16-bit)
-**	- interlace_type 0 (no interlacing)
-**	- color_type 0, 2, or 3 (no alpha-channel); color type 3 requires
-**        libpng for palette processing
-*/
-#define SPNG_SIGNATURE	"\211\120\116\107\015\012\032\012"
-
-#define SPNG_CHUNK_IHDR	0x49484452
-#define SPNG_CHUNK_PLTE	0x504C5445
-#define SPNG_CHUNK_tRNS	0x74524E53
-#define SPNG_CHUNK_IDAT	0x49444154
-#define SPNG_CHUNK_IEND	0x49454E44
-
-/* spng_init() return codes
-*/
-#define SPNG_ERR_OK	0	/* no error */
-#define SPNG_ERR_NOPNG	1	/* bad PNG signature */
-#define SPNG_ERR_FMT	2	/* bad PNG file format */
-
-typedef struct
-{
-    /* from IHDR:
-    */
-    int		width;
-    int		height;
-    pdc_byte	bit_depth;
-    pdc_byte	color_type;
-    pdc_byte	compr_type;
-    pdc_byte	filter_type;
-    pdc_byte	interlace_type;
-} spng_info;
-
-static int
-spng_getint(pdc_file *fp)
-{
-    unsigned char buf[4];
-
-    if (!PDC_OK_FREAD(fp, buf, 4))
-	return -1;
-
-    return (int) pdc_get_be_long(buf);
-} /* spng_getint */
-
-static int
-spng_init(PDF *p, pdf_image *image, spng_info *spi)
-{
-    pdc_file *fp = image->fp;
-    char buf[8];
-
-    (void) p;
-
-    /* check signature
-    */
-    if (!PDC_OK_FREAD(fp, buf, 8) ||
-        strncmp(buf, SPNG_SIGNATURE, 8) != 0)
-	return SPNG_ERR_NOPNG;
-
-    /* read IHDR
-    */
-    if (spng_getint(fp) != 13 ||
-        spng_getint(fp) != SPNG_CHUNK_IHDR)
-	return SPNG_ERR_FMT;
-
-    spi->width = spng_getint(fp);
-    spi->height = spng_getint(fp);
-
-    if (!PDC_OK_FREAD(fp, buf, 5))
-	return SPNG_ERR_FMT;
-
-    spi->bit_depth	= (pdc_byte) buf[0];
-    spi->color_type	= (pdc_byte) buf[1];
-    spi->compr_type	= (pdc_byte) buf[2];
-    spi->filter_type	= (pdc_byte) buf[3];
-    spi->interlace_type	= (pdc_byte) buf[4];
-
-    (void) spng_getint(fp);     /* CRC */
-
-    /* decide whether this image is "simple".
-    */
 #ifdef HAVE_LIBPNG
-    if (spi->bit_depth > 8 || spi->color_type > 3 || spi->interlace_type != 0)
-#else
-    if (spi->bit_depth > 8 || spi->color_type > 2 || spi->interlace_type != 0)
-#endif	/* !HAVE_LIBPNG */
-    {
-	image->use_raw = pdc_false;
-	return SPNG_ERR_OK;
-    }
-    else
-	image->use_raw = pdc_true;
-
-    /* read (or skip) all chunks up to the first IDAT.
-    */
-    for (/* */ ; /* */ ; /* */)
-    {
-        int len = spng_getint(fp);
-        int type = spng_getint(fp);
-
-	switch (type)
-	{
-	    case SPNG_CHUNK_IDAT:		/* prepare data xfer	*/
-		image->info.png.nbytes = (size_t) len;
-		return SPNG_ERR_OK;
-
-	    case -1:
-		return SPNG_ERR_FMT;
-
-	    /* if we decide to live without LIBPNG,
-	    ** we should handle these cases, too.
-	    */
-	    case SPNG_CHUNK_tRNS:		/* transparency chunk	*/
-	    case SPNG_CHUNK_PLTE:		/* read in palette	*/
-
-	    default:
-                pdc_fseek(fp, len + 4, SEEK_CUR);
-                                                /* skip data & CRC      */
-		break;
-	} /* switch */
-    } /* for */
-
-    /* return SPNG_ERR_OK; never reached! */
-} /* spng_init */
-
-#define PDF_PNG_BUFFERSIZE	8192
 
 static void
 pdf_data_source_PNG_init(PDF *p, PDF_data_source *src)
 {
-    static const char fn[] = "pdf_data_source_PNG_init";
-#ifdef HAVE_LIBPNG
     pdf_image   *image = (pdf_image *) src->private_data;
 
-    if (image->use_raw)
-    {
-#endif
-	src->buffer_length = PDF_PNG_BUFFERSIZE;
-	src->buffer_start = (pdc_byte *)
-	    pdc_malloc(p->pdc, src->buffer_length, fn);
-	src->bytes_available = 0;
-	src->next_byte = src->buffer_start;
+    (void) p;
 
-#ifdef HAVE_LIBPNG
-    }
-    else
-    {
-	image->info.png.cur_line = 0;
-	src->buffer_length = image->info.png.rowbytes;
-    }
-#endif
+    image->info.png.cur_line = 0;
+    src->buffer_length = image->info.png.rowbytes;
 }
 
 #undef min
 #define min(a, b) (((a) < (b)) ? (a) : (b))
 
-static void
-spng_error(PDF *p, PDF_data_source *src)
-{
-    pdf_image	*image = (pdf_image *) src->private_data;
-
-    pdc_error(p->pdc, PDF_E_IMAGE_CORRUPT, "PNG",
-              pdf_get_image_filename(p, image), 0, 0);
-} /* spng_error */
-
 static pdc_bool
 pdf_data_source_PNG_fill(PDF *p, PDF_data_source *src)
 {
@@ -198,69 +47,18 @@
 
     PDC_TRY(p->pdc)
     {
-#ifdef HAVE_LIBPNG
-        if (image->use_raw)
-        {
-#endif
-            pdc_file *	fp = image->fp;
-            size_t	buf_avail = src->buffer_length;
-            pdc_byte *scan = src->buffer_start;
-
-            src->bytes_available = 0;
-
-            if (image->info.png.nbytes == 0)
-            {
-                PDC_EXIT_TRY(p->pdc);
-                return pdc_false;
-            }
-
-            do
-            {
-                size_t nbytes = min(image->info.png.nbytes, buf_avail);
-
-                if (!PDC_OK_FREAD(fp, scan, nbytes))
-                    spng_error(p, src);
-
-                src->bytes_available += nbytes;
-                scan += nbytes;
-                buf_avail -= nbytes;
-
-                if ((image->info.png.nbytes -= nbytes) == 0)
-                {
-                    /* proceed to next IDAT chunk
-                    */
-                    (void) spng_getint(fp);                    /* CRC */
-                    image->info.png.nbytes =
-                         (size_t) spng_getint(fp);             /* length */
-
-                    if (spng_getint(fp) != SPNG_CHUNK_IDAT)
-                    {
-                        image->info.png.nbytes = 0;
-                        PDC_EXIT_TRY(p->pdc);
-                        return pdc_true;
-                    }
-                }
-            }
-            while (buf_avail);
-
-#ifdef HAVE_LIBPNG
-        }
-        else
-        {
-            if (image->info.png.cur_line == image->height)
-            {
-                PDC_EXIT_TRY(p->pdc);
-                return pdc_false;
-            }
+	if (image->info.png.cur_line == image->height)
+	{
+	    PDC_EXIT_TRY(p->pdc);
+	    return pdc_false;
+	}
 
-            src->next_byte = image->info.png.raster +
-                image->info.png.cur_line * image->info.png.rowbytes;
+	src->next_byte = image->info.png.raster +
+	    image->info.png.cur_line * image->info.png.rowbytes;
 
-            src->bytes_available = src->buffer_length;
+	src->bytes_available = src->buffer_length;
 
-            image->info.png.cur_line++;
-        }
-#endif	/* HAVE_LIBPNG */
+	image->info.png.cur_line++;
     }
     PDC_CATCH(p->pdc)
     {
@@ -273,21 +71,10 @@
 static void
 pdf_data_source_PNG_terminate(PDF *p, PDF_data_source *src)
 {
-#ifdef HAVE_LIBPNG
-    pdf_image   *image = (pdf_image *) src->private_data;
-
-    if (image->use_raw)
-    {
-#endif
-	pdc_free(p->pdc, (void *) src->buffer_start);
-
-#ifdef HAVE_LIBPNG
-    }
-#endif
+    (void) p;
+    (void) src;
 }
 
-#ifdef HAVE_LIBPNG
-
 static void
 pdf_png_read_data(png_structp png_ptr, png_bytep data, png_size_t length)
 {
@@ -309,11 +96,8 @@
 static void
 pdf_libpng_warning_handler(png_structp png_ptr, png_const_charp message)
 {
-    (void) png_ptr;	/* avoid compiler warning "unreferenced parameter" */
-    (void) message;	/* avoid compiler warning "unreferenced parameter" */
-
-    /* do nothing */
-    return;
+    PDF *p = (PDF *)png_ptr->mem_ptr;
+    pdc_logg_cond(p->pdc, 5, trc_image, "\tlibpng warning: %s\n", message);
 }
 
 /*
@@ -326,11 +110,13 @@
 static void
 pdf_libpng_error_handler(png_structp png_ptr, png_const_charp message)
 {
+    PDF *p = (PDF *)png_ptr->mem_ptr;
+
 #ifdef PDF_ALIGN16
     jmp_buf jbuf;
 #endif
 
-    (void) message;	/* avoid compiler warning "unreferenced parameter" */
+    pdc_logg_cond(p->pdc, 5, trc_image, "\tlibpng error: %s\n", message);
 
 #ifdef PDF_ALIGN16
     memcpy(jbuf, png_jmpbuf(png_ptr), sizeof (jmp_buf));
@@ -377,7 +163,7 @@
 {
     static const char *fn = "pdf_process_PNG_data";
     pdc_file *save_fp;
-    spng_info s_info;
+    size_t bytecount;
 #ifdef PDF_ALIGN16
     jmp_buf jbuf;
 #endif
@@ -671,6 +457,14 @@
     image->info.png.rowbytes =
 	png_get_rowbytes(image->info.png.png_ptr, image->info.png.info_ptr);
 
+    /* Check for overflow */
+    bytecount = image->info.png.rowbytes * height;
+    if (bytecount / height != image->info.png.rowbytes)
+    {
+	errcode = PDF_E_IMAGE_TOO_LARGE;
+	goto PDF_PNG_ERROR;
+    }
+
     image->info.png.raster = (pdc_byte *)
 	pdc_calloc(p->pdc,image->info.png.rowbytes * height, fn);
 
@@ -695,60 +489,50 @@
 
     image->fp = pdc_fsearch_fopen(p->pdc, image->filename, NULL, NULL,
                                   PDC_FILE_BINARY);
-    if (image->fp != NULL &&
-        spng_init(p, image, &s_info) == SPNG_ERR_OK && image->use_raw)
-    {
-        pdc_fclose(save_fp);
-	image->predictor	= pred_png;
-        image->compression      = pdf_comp_flate;
-    }
-    else
-    {
-	if (image->fp != (pdc_file *) 0)
-            pdc_fclose(image->fp);
+    if (image->fp != (pdc_file *) 0)
+	pdc_fclose(image->fp);
 
-	image->fp = save_fp;
+    image->fp = save_fp;
+
+    /* Provide a suitable background for images with alpha channel */
+    if (color_type == PNG_COLOR_TYPE_GRAY_ALPHA ||
+	color_type == PNG_COLOR_TYPE_RGB_ALPHA)
+    {
+	png_color_16p image_background;
 
-	/* Provide a suitable background for images with alpha channel */
-	if (color_type == PNG_COLOR_TYPE_GRAY_ALPHA ||
-	    color_type == PNG_COLOR_TYPE_RGB_ALPHA)
+	if (png_get_bKGD(image->info.png.png_ptr, image->info.png.info_ptr,
+			&image_background))
 	{
-	    png_color_16p image_background;
+	    png_set_background(image->info.png.png_ptr, image_background,
+		PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
+	}
+	else
+	{
+	    png_color_16 my_white;
 
-	    if (png_get_bKGD(image->info.png.png_ptr, image->info.png.info_ptr,
-			    &image_background))
+	    if (bit_depth == 8)
 	    {
-		png_set_background(image->info.png.png_ptr, image_background,
-		    PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
+		my_white.red	= 0xFF;
+		my_white.green	= 0xFF;
+		my_white.blue	= 0xFF;
+		my_white.gray	= 0xFF;
 	    }
 	    else
 	    {
-		png_color_16 my_white;
-
-		if (bit_depth == 8)
-		{
-		    my_white.red	= 0xFF;
-		    my_white.green	= 0xFF;
-		    my_white.blue	= 0xFF;
-		    my_white.gray	= 0xFF;
-		}
-                else
-		{
-		    my_white.red	= 0xFFFF;
-		    my_white.green	= 0xFFFF;
-		    my_white.blue	= 0xFFFF;
-		    my_white.gray	= 0xFFFF;
-		}
-
-		png_set_background(image->info.png.png_ptr, &my_white,
-		    PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
+		my_white.red	= 0xFFFF;
+		my_white.green	= 0xFFFF;
+		my_white.blue	= 0xFFFF;
+		my_white.gray	= 0xFFFF;
 	    }
-	}
 
-	/* fetch the actual image data */
-	png_read_image(image->info.png.png_ptr, row_pointers);
+	    png_set_background(image->info.png.png_ptr, &my_white,
+		PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);
+	}
     }
 
+    /* fetch the actual image data */
+    png_read_image(image->info.png.png_ptr, row_pointers);
+
     image->in_use		= pdc_true;		/* mark slot as used */
 
     pdf_put_image(p, imageslot, pdc_true, pdc_true);
@@ -791,6 +575,12 @@
 		pdc_set_errmsg(p->pdc, errcode, "PNG", stemp, 0, 0);
 		break;
 
+            case PDF_E_IMAGE_TOO_LARGE:
+		pdc_set_errmsg(p->pdc, errcode, "PNG", stemp,
+		    pdc_errprintf(p->pdc, "%ld", (long) image->width),
+		    pdc_errprintf(p->pdc, "%ld", (long) image->height));
+		break;
+
 	    case 0: 		/* error code and message already set */
 		break;
         }
@@ -810,52 +600,14 @@
     return pdc_false;
 }
 
-/* simple built-in PNG reader without libpng */
-
 int
-pdf_process_PNG_data(
-    PDF *p,
-    int imageslot)
+pdf_process_PNG_data(PDF *p, int imageslot)
 {
-    spng_info s_info;
-    pdf_image *image;
+    (void) imageslot;
 
-    image = &p->images[imageslot];
+    pdc_set_errmsg(p->pdc, PDF_E_UNSUPP_IMAGE, "PNG", 0, 0, 0);
 
-    image->src.init		= pdf_data_source_PNG_init;
-    image->src.fill		= pdf_data_source_PNG_fill;
-    image->src.terminate	= pdf_data_source_PNG_terminate;
-    image->src.private_data	= (void *) image;
-
-    if (spng_init(p, image, &s_info) == SPNG_ERR_OK && image->use_raw)
-    {
-	image->predictor	= pred_png;
-	image->compression	= pdf_comp_flate;
-
-        image->width            = (pdc_scalar) s_info.width;
-        image->height           = (pdc_scalar) s_info.height;
-	image->bpc		= s_info.bit_depth;
-
-	image->components	= 3;
-
-	/* other types are rejected in spng_init() */
-	image->colorspace	=
-			(s_info.color_type == 0 ? DeviceGray : DeviceRGB);
-
-
-
-    }
-    else
-    {
-	pdc_set_errmsg(p->pdc, PDF_E_UNSUPP_IMAGE, "PNG", 0, 0, 0);
-	return -1;
-    }
-
-    image->in_use           = pdc_true;             /* mark slot as used */
-
-    pdf_put_image(p, imageslot, pdc_true, pdc_true);
-
-    return image->corrupt ? -1 : imageslot;
+    return -1;
 }
 
 #endif	/* !HAVE_LIBPNG */
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_shading.c PDFlib-Lite-7.0.4/libs/pdflib/p_shading.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_shading.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_shading.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_shading.c,v 1.52.2.1 2007/06/14 18:15:22 kurt Exp $
+/* $Id: p_shading.c,v 1.52.2.2 2009/06/04 11:22:04 york Exp $
  *
  * PDFlib routines for smooth shading
  *
@@ -68,13 +68,12 @@
 pdf_write_page_shadings(PDF *p)
 {
     int i, total = 0;
-    int bias = p->curr_ppt->sh_bias;
 
     for (i = 0; i < p->shadings_number; i++)
 	if (p->shadings[i].used_on_current_page)
 	    total++;
 
-    if (total > 0 || bias)
+    if (total > 0)
     {
 	pdc_puts(p->out, "/Shading");
 	pdc_begin_dict(p->out);
@@ -87,12 +86,11 @@
 	    if (p->shadings[i].used_on_current_page)
 	    {
 		p->shadings[i].used_on_current_page = pdc_false; /* reset */
-		pdc_printf(p->out, "/Sh%d", bias + i);
+		pdc_printf(p->out, "/Sh%d", i);
 		pdc_objref(p->out, "", p->shadings[i].obj_id);
 	    }
 	}
 
-	if (!bias)
 	    pdc_end_dict(p->out);
     }
 }
@@ -201,15 +199,13 @@
 void
 pdf__shfill(PDF *p, int shading)
 {
-    int bias = p->curr_ppt->sh_bias;
-
     if (p->compatibility == PDC_1_3)
 	pdc_error(p->pdc, PDF_E_SHADING13, 0, 0, 0, 0);
 
     pdf_check_handle(p, shading, pdc_shadinghandle);
 
     pdf_end_text(p);
-    pdc_printf(p->out, "/Sh%d sh\n", bias + shading);
+    pdc_printf(p->out, "/Sh%d sh\n", shading);
 
     p->shadings[shading].used_on_current_page = pdc_true;
 }
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_subsett.c PDFlib-Lite-7.0.4/libs/pdflib/p_subsett.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_subsett.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_subsett.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_subsett.c,v 1.104.2.24 2008/11/18 18:42:20 kurt Exp $
+/* $Id: p_subsett.c,v 1.104.2.25 2009/03/26 14:28:04 kurt Exp $
  *
  * PDFlib subsetting routines
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_table.c PDFlib-Lite-7.0.4/libs/pdflib/p_table.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_table.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_table.c	2009-06-08 17:57:29.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_table.c,v 1.88.2.35 2009/02/27 17:01:02 kurt Exp $
+/* $Id: p_table.c,v 1.88.2.38 2009/05/08 10:25:23 kurt Exp $
  *
  * PDFlib table function
  *
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdflib/p_template.c PDFlib-Lite-7.0.4/libs/pdflib/p_template.c
--- PDFlib-Lite-7.0.4.bak/libs/pdflib/p_template.c	2009-03-18 15:10:07.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdflib/p_template.c	2009-06-08 17:57:30.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: p_template.c,v 1.82.2.8 2008/01/08 18:39:10 kurt Exp $
+/* $Id: p_template.c,v 1.82.2.9 2009/04/15 12:06:35 york Exp $
  *
  * PDFlib template routines
  *
@@ -66,6 +66,9 @@
 {
     {"topdown", pdc_booleanlist, PDC_OPT_NONE, 1, 1, 0.0, 0.0, NULL},
 
+    {"transparencygroup", pdc_stringlist,  PDC_OPT_PDC_1_4, 1, 1,
+      1.0, PDF_MAX_NAMESTRING, NULL},
+
     {"OPI-1.3", pdc_stringlist, PDF_OPIOPT_FLAG, 1, 1, 0.0, 32000.0, NULL},
 
     {"OPI-2.0", pdc_stringlist, PDF_OPIOPT_FLAG | PDC_OPT_IGNOREIF1,
@@ -115,6 +118,9 @@
     image->topdown_save = (p->ydirection == -1) ? pdc_true : pdc_false;
     topdown = image->topdown_save;
     image->in_use = pdc_true;                 /* mark slot as used */
+    image->tgroup.colorspace = color_none;
+    image->tgroup.isolated = pdc_false;
+    image->tgroup.knockout = pdc_false;
 
     /* parsing optlist */
     pdf_set_clientdata(p, &cdata);
@@ -124,11 +130,16 @@
     /* save and check options */
     if (optlist && *optlist)
     {
+	char **slist;
+
         image->verbose = pdf_get_errorpolicy(p, resopts, image->verbose);
 
         keyword = "topdown";
         pdc_get_optvalues(keyword, resopts, &topdown, NULL);
 
+	if (pdc_get_optvalues("transparencygroup", resopts, NULL, &slist))
+	    pdf_set_transgroup(p, slist[0], &image->tgroup);
+
         keyword = "iconname";
         if (pdc_get_optvalues(keyword, resopts, NULL, NULL))
             iconname = (char *) pdc_save_lastopt(resopts, PDC_OPT_SAVE1ELEM);
@@ -169,6 +180,9 @@
 
     pdc_printf(p->out, "/BBox[0 0 %f %f]\n", width, height);
 
+    if (image->tgroup.colorspace != color_none)
+	pdf_write_transgroup(p, &image->tgroup);
+
 
 
 
